# LDLFactorizations: Factorization of Symmetric Matrices

A translation of Tim Davis's Concise LDLᵀ Factorization, part of [SuiteSparse](http://faculty.cse.tamu.edu/davis/suitesparse.html) with several improvements.

[![DOI](https://zenodo.org/badge/98073166.svg)](https://zenodo.org/badge/latestdoi/98073166)
![CI](https://github.com/JuliaSmoothOptimizers/LDLFactorizations.jl/workflows/CI/badge.svg?branch=main)
[![Build Status](https://api.cirrus-ci.com/github/JuliaSmoothOptimizers/LDLFactorizations.jl.svg)](https://cirrus-ci.com/github/JuliaSmoothOptimizers/LDLFactorizations.jl)
[![codecov](https://codecov.io/gh/JuliaSmoothOptimizers/LDLFactorizations.jl/branch/main/graph/badge.svg)](https://codecov.io/gh/JuliaSmoothOptimizers/LDLFactorizations.jl)
[![Documentation/stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaSmoothOptimizers.github.io/LDLFactorizations.jl/stable)
[![Documentation/dev](https://img.shields.io/badge/docs-latest-blue.svg)](https://JuliaSmoothOptimizers.github.io/LDLFactorizations.jl/dev)

This package is appropriate for matrices A that possess a factorization of the
form LDLᵀ without pivoting, where L is unit lower triangular and D is *diagonal* (indefinite in general), including definite and quasi-definite matrices.

LDLFactorizations.jl should not be expected to be as fast, as robust or as accurate as factorization
packages such as [HSL.jl](https://github.com/JuliaSmoothOptimizers/HSL.jl), [MUMPS.jl](https://github.com/JuliaSmoothOptimizers/MUMPS.jl) or [Pardiso.jl](https://github.com/JuliaSparse/Pardiso.jl).
Those are multifrontal and/or implement various forms of parallelism, and
employ sophisticated pivot strategies.

The main advantages of LDLFactorizations.jl are that

1. it is very short and has a small footprint;
2. it is in pure Julia, and so

   2.a. it does not require external compiled dependencies;

   2.b. it will work with multiple input data types.

Whereas MUMPS.jl, HSL.jl and Pardiso.jl only work with single and double precision
reals and complex data types, LDLFactorizations.jl accepts any numerical data type.

# Installing

```julia
julia> ]
pkg> add LDLFactorizations
```

# Usage

The only exported functions are `ldl()`, `\` and `ldiv!`.
Calling `ldl()` with a dense array converts it to a sparse matrix.
A permutation ordering can be supplied: `ldl(A, p)` where `p` is an `Int`
array representing a permutation of the integers between 1 and the order
of `A`.
If no permutation is supplied, one is automatically computed using [AMD.jl](https://github.com/JuliaSmoothOptimizers/AMD.jl).
Only the upper triangle of `A` is accessed.

`ldl` returns a factorization in the form of a `LDLFactorization` object.
The `\` and `ldiv!` methods are implemented for objects of type `LDLFactorization` so that
solving a linear system is as easy as
```julia
LDLT = ldl(A)  # LDLᵀ factorization of A

x = LDLT \ b   # solves Ax = b

ldiv!(LDLT, b)     # computes LDLT \ b in-place and overwriting b to store the result
y = similar(b)
ldiv!(y, LDLT, b)  # computes LDLT \ b in-place and store the result in y
```
The factorization can of course be reused to solve for multiple right-hand
sides.

Factors can be accessed as `LDLT.L` and `LDLT.D`, and the permutation vector as `LDLT.P`.
Because the L factor is unit lower triangular, its diagonal is not stored.
Thus the factors satisfy: PAPᵀ = (L + I) D (L + I)ᵀ.

# References

> Timothy A. Davis.
> Algorithm 849: A concise sparse Cholesky factorization package.
> ACM Trans. Math. Softw. 31, 4 (December 2005), 587-591.
> DOI:[10.1145/1114268.1114277](http://dx.doi.org/10.1145/1114268.1114277).

If you use LDLFactorizations.jl in your work, please cite using the format given in [CITATION.cff](CITATION.cff).

Like the original LDL, this package is distributed under the LGPL.

[![LGPLv3](http://www.gnu.org/graphics/lgplv3-88x31.png)](http://www.gnu.org/licenses/lgpl.html "LGPLv3")

## Bug reports and discussions

If you think you found a bug, feel free to open an [issue](https://github.com/JuliaSmoothOptimizers/LDLFactorizations.jl/issues).
Focused suggestions and requests can also be opened as issues. Before opening a pull request, start an issue or a discussion on the topic, please.

If you want to ask a question not suited for a bug report, feel free to start a discussion [here](https://github.com/JuliaSmoothOptimizers/Organization/discussions). This forum is for general discussion about this repository and the [JuliaSmoothOptimizers](https://github.com/JuliaSmoothOptimizers) organization, so questions about any of our packages are welcome.

@testset "complex" begin
  @testset "factorizable" begin
    # this matrix possesses an LDLᵀ factorization without pivoting
    #! format: off
    A = [
      1.7     0       0   0   0       0   0       0       0.13+im 0
      0       1.0     0   0   0.02+im 0   0       0       0       0.01+im
      0       0       1.5 0   0       0   0       0       0       0
      0       0       0   1.1 0       0   0       0       0       0
      0       0.02-im 0   0   2.6     0   0.16+im 0.09+im 0.52+im 0.53+im
      0       0       0   0   0       1.2 0       0       0       0
      0       0       0   0   0.16-im 0   1.3     0       0       0.56+im
      0       0       0   0   0.09-im 0   0       1.6     0.11+im 0
      0.13-im 0       0   0   0.52-im 0   0       0.11-im 1.4     0
      0       0.01-im 0   0   0.53-im 0   0.56-im 0       0       3.1
    ]
    #! format: on
    b = [
      0.287 + 0.9im,
      0.22 + 1.5im,
      0.45,
      0.44,
      2.486 + 3.2im,
      0.72,
      1.55 + 0.5im,
      1.424 + 0.4im,
      1.621 - 1.4im,
      3.759 - 1.4im,
    ]
    ϵ = sqrt(eps(real(eltype(A))))

    LDLT = ldl(A)
    x = LDLT \ b

    r = A * x - b
    @test norm(r) ≤ ϵ * norm(b)

    y = collect(0.1:0.1:1)
    @test norm(x - y) ≤ ϵ * norm(y)

    x2 = copy(b)
    ldiv!(LDLT, x2)

    r2 = A * x2 - b
    @test norm(r2) ≤ ϵ * norm(b)

    @test norm(x2 - y) ≤ ϵ * norm(y)

    @test norm(A[LDLT.P, LDLT.P] - (LDLT.L + I) * LDLT.D * (LDLT.L + I)') ≤ ϵ

    # test properties
    @test eltype(LDLT) == eltype(A)
    @test nnz(LDLT) == nnz(LDLT.L) + length(LDLT.d)
    @test size(LDLT) == size(A)
    @test typeof(LDLT.D) <: Diagonal
    @test propertynames(LDLT) == (:L, :D, :P)
  end

  @testset "factorizable_upper" begin
    # Using only the upper triangle tests
    #! format: off
    A = [
      1.7     0       0   0   0       0   0       0       0.13+im 0
      0       1.0     0   0   0.02+im 0   0       0       0       0.01+im
      0       0       1.5 0   0       0   0       0       0       0
      0       0       0   1.1 0       0   0       0       0       0
      0       0.02-im 0   0   2.6     0   0.16+im 0.09+im 0.52+im 0.53+im
      0       0       0   0   0       1.2 0       0       0       0
      0       0       0   0   0.16-im 0   1.3     0       0       0.56+im
      0       0       0   0   0.09-im 0   0       1.6     0.11+im 0
      0.13-im 0       0   0   0.52-im 0   0       0.11-im 1.4     0
      0       0.01-im 0   0   0.53-im 0   0.56-im 0       0       3.1
    ]
    #! format: on
    b = [
      0.287 + 0.9im,
      0.22 + 1.5im,
      0.45,
      0.44,
      2.486 + 3.2im,
      0.72,
      1.55 + 0.5im,
      1.424 + 0.4im,
      1.621 - 1.4im,
      3.759 - 1.4im,
    ]
    ϵ = sqrt(eps(real(eltype(A))))
    LDLT = ldl(A)

    A_upper = Hermitian(triu(A), :U)
    LDLT_upper = ldl(A_upper)
    x = LDLT_upper \ b

    y = collect(0.1:0.1:1)
    @test norm(x - y) ≤ ϵ * norm(y)

    r = A * x - b
    @test norm(r) ≤ ϵ * norm(b)

    x2 = copy(b)
    ldiv!(LDLT, x2)
    @test norm(x2 - y) ≤ ϵ * norm(y)

    r2 = A * x2 - b
    @test norm(r2) ≤ ϵ * norm(b)

    @test nnz(LDLT_upper) == nnz(LDLT_upper.L) + length(LDLT_upper.d)

    # test with separate analyze/factorize phases
    S = ldl_analyze(A)
    ldl_factorize!(A, S)
    x2 = copy(b)
    ldiv!(LDLT, x2)
    @test norm(x2 - y) ≤ ϵ * norm(y)
    r2 = A * x2 - b
    @test norm(r2) ≤ ϵ * norm(b)

    # test with a permutation of a different int type
    p = Int32.(collect(size(A, 1):-1:1))
    LDLT_upper = ldl(A_upper, P = p)
    x = LDLT_upper \ b

    y = collect(0.1:0.1:1)
    @test norm(x - y) ≤ ϵ * norm(y)

    r = A * x - b
    @test norm(r) ≤ ϵ * norm(b)

    x2 = copy(b)
    ldiv!(LDLT, x2)
    @test norm(x2 - y) ≤ ϵ * norm(y)

    r2 = A * x2 - b
    @test norm(r2) ≤ ϵ * norm(b)

    # Tests with multiple right-hand sides
    B = one(ComplexF64) * [i + j for j = 1:10, i = 0:3]
    X = A \ B
    Y = similar(B)
    ldiv!(Y, LDLT, B)
    @test norm(Y - X) ≤ ϵ * norm(X)
  end
end

using Documenter, LDLFactorizations

makedocs(
  modules = [LDLFactorizations],
  doctest = true,
  linkcheck = true,
  format = Documenter.HTML(
    assets = ["assets/style.css"],
    prettyurls = get(ENV, "CI", nothing) == "true",
  ),
  sitename = "LDLFactorizations.jl",
  pages = Any["Home" => "index.md", "Tutorial" => "tutorial.md", "Reference" => "reference.md"],
)

deploydocs(
  repo = "github.com/JuliaSmoothOptimizers/LDLFactorizations.jl.git",
  push_preview = true,
  devbranch = "main",
)

# benchmark file to compare two commits of LDLFactorizations

using BenchmarkTools
using MatrixMarket

using DelimitedFiles
using LinearAlgebra
using Pkg.Artifacts
using Printf
using SparseArrays

using LDLFactorizations

# obtain path to SQD collection
const artifact_toml = joinpath(@__DIR__, "Artifacts.toml")
ensure_artifact_installed("sqdcollection", artifact_toml)
const sqd_hash = artifact_hash("sqdcollection", artifact_toml)
@assert artifact_exists(sqd_hash)
const sqd_path = joinpath(artifact_path(sqd_hash), "sqd-collection-0.1")
subdirs = readdir(sqd_path)
const formulations = ("2x2", "3x3")
const iters = (0, 5, 10)

const SUITE = BenchmarkGroup()
SUITE["analyze"] = BenchmarkGroup()
SUITE["factorize"] = BenchmarkGroup()
SUITE["solve1"] = BenchmarkGroup()
SUITE["solve5"] = BenchmarkGroup()

for subdir ∈ subdirs
  subdir == ".git" && continue
  isdir(joinpath(sqd_path, subdir)) || continue  # ignore regular files
  for formulation ∈ formulations
    for iter ∈ iters
      iterpath = joinpath(sqd_path, subdir, formulation, "iter_$(iter)")
      isdir(iterpath) || continue
      A = MatrixMarket.mmread(joinpath(iterpath, "K_$(iter).mtx"))
      b = readdlm(joinpath(iterpath, "rhs_$(iter).rhs"))[:, 1]
      B = [b b b b b]
      name = "$(subdir)_$(formulation)_$(iter)"
      SUITE["analyze"][name] = @benchmarkable ldl_analyze($A)
      LDL = ldl_analyze(A)
      SUITE["factorize"][name] = @benchmarkable ldl_factorize!($A, $LDL)
      ldl_factorize!(A, LDL)
      x = similar(b)
      SUITE["solve1"][name] = @benchmarkable ldiv!($x, $LDL, $b)
      X = similar(B)
      SUITE["solve5"][name] = @benchmarkable ldiv!($X, $LDL, $B)
    end
  end
end

module LDLFactorizations

export LDLFactorization
export ldl, ldl_analyze, ldl_factorize!, factorized, \, ldiv!, lmul!, mul!, nnz, -

using AMD, LinearAlgebra, SparseArrays

mutable struct SQDException <: Exception
  msg::String
end

const error_string = "LDL' factorization was not computed or failed"

"""
    col_symb!(n, Ap, Ai, Cp, w, Pinv)
Compute the sparse structure of missing elements of the upper triangle of PAPt. Nonzero elements have to verify Pinv[i] < Pinv[j] where i is the
row index and j the column index. Those elements are the nonzeros of the lower triangle of A that will be in the upper triangle of PAPt (after permutation)
# Arguments
- `n::Ti`: number of columns of the matrix
- `Ap::Vector{Ti}`: colptr of the matrix to factorize (CSC format)
- `Ai::Vector{Ti}`: rowval of the matrix to factorize (CSC format)
- `Cp::Vector{Ti}`: colptr of the lower triangle (to be modified)
- `w::Vector{Ti}`: work array
- `Pinv::Vector{Ti}`: inverse permutation of P. PAPt is the matrix to factorize (CSC format)
"""
function col_symb!(n, Ap, Ai, Cp, w, Pinv)
  fill!(w, 0)
  @inbounds for j = 1:n
    @inbounds for p = Ap[j]:(Ap[j + 1] - 1)
      i = Ai[p]
      i >= j && break  # only upper part
      Pinv[i] < Pinv[j] && continue  # store only what will be used during the factorization
      w[i] += 1  # count entries
    end
  end

  Cp[1] = 1
  @inbounds for i = 1:n  # cumulative sum
    Cp[i + 1] = w[i] + Cp[i]
    w[i] = Cp[i]
  end
end

"""
    col_num!(n, Ap, Ai, Ci, w, Pinv)
    
Compute the rowval and values of missing elements of the upper triangle of PAPt. Nonzero elements have to verify Pinv[i] ≥ Pinv[j] where i is the
row index and j the column index. Those elements are the nonzeros of the lower triangle of A that will be in the upper triangle of PAPt (after permutation)
# Arguments
- `n::Ti`: number of columns of the matrix
- `Ap::Vector{Ti}`: colptr of the matrix to factorize (CSC format)
- `Ai::Vector{Ti}`: rowval of the matrix to factorize (CSC format)
- `Ci::Vector{Ti}`: rowval of the lower triangle
- `w::Vector{Ti}`: work array
- `Pinv::Vector{Ti}`: inverse permutation of P. PAPt is the matrix to factorize (CSC format)
"""
function col_num!(n, Ap, Ai, Ci, w, Pinv)
  @inbounds for j = 1:n
    @inbounds for p = Ap[j]:(Ap[j + 1] - 1)
      i = Ai[p]
      i >= j && break  # only upper part
      Pinv[i] < Pinv[j] && continue  # store only what will be used during the factorization
      Ci[w[i]] = j
      w[i] += 1
    end
  end
end

function ldl_symbolic_upper!(n, Ap, Ai, Cp, Ci, Lp, parent, Lnz, flag, P, Pinv)
  @inbounds for k = 1:n
    parent[k] = -1
    flag[k] = k
    Lnz[k] = 0
    pk = P[k]
    @inbounds for p = Ap[pk]:(Ap[pk + 1] - 1)
      i = Pinv[Ai[p]]
      i ≥ k && continue
      @inbounds while flag[i] != k
        if parent[i] == -1
          parent[i] = k
        end
        Lnz[i] += 1
        flag[i] = k
        i = parent[i]
      end
    end

    # Missing nonzero elements of the upper triangle
    @inbounds for ind = Cp[pk]:(Cp[pk + 1] - 1)
      i = Pinv[Ci[ind]]
      i > k && continue
      @inbounds while flag[i] != k
        if parent[i] == -1
          parent[i] = k
        end
        Lnz[i] += 1
        flag[i] = k
        i = parent[i]
      end
    end
  end
  Lp[1] = 1
  @inbounds for k = 1:n
    Lp[k + 1] = Lp[k] + Lnz[k]
  end
end

function ldl_symbolic!(n, Ap, Ai, Lp, parent, Lnz, flag, P, Pinv)
  @inbounds for k = 1:n
    parent[k] = -1
    flag[k] = k
    Lnz[k] = 0
    pk = P[k]
    @inbounds for p = Ap[pk]:(Ap[pk + 1] - 1)
      i = Pinv[Ai[p]]
      i ≥ k && continue
      @inbounds while flag[i] != k
        if parent[i] == -1
          parent[i] = k
        end
        Lnz[i] += 1
        flag[i] = k
        i = parent[i]
      end
    end
  end
  Lp[1] = 1
  @inbounds for k = 1:n
    Lp[k + 1] = Lp[k] + Lnz[k]
  end
end

function ldl_numeric_upper!(
  n,
  Ap,
  Ai,
  Ax,
  Cp,
  Ci,
  Lp,
  parent,
  Lnz,
  Li,
  Lx,
  D,
  Y::T,
  pattern,
  flag,
  P,
  Pinv,
  r1,
  r2,
  tol,
  n_d,
) where {T}
  dynamic_reg = r1 != 0 || r2 != 0
  Y_zero = zero(eltype(T))
  @inbounds for k = 1:n
    Y[k] = Y_zero
    top = n + 1
    flag[k] = k
    Lnz[k] = 0
    pk = P[k]
    @inbounds for p = Ap[pk]:(Ap[pk + 1] - 1)
      i = Pinv[Ai[p]]
      i > k && continue
      Y[i] += Ax[p]
      len = 1
      @inbounds while flag[i] != k
        pattern[len] = i
        len += 1
        flag[i] = k
        i = parent[i]
      end
      @inbounds while len > 1
        top -= 1
        len -= 1
        pattern[top] = pattern[len]
      end
    end
    # missing non zero elements of the upper triangle
    @inbounds for ind = Cp[pk]:(Cp[pk + 1] - 1)
      i2 = Ci[ind]
      i = Pinv[i2]
      i > k && continue
      @inbounds for p = Ap[i2]:(Ap[i2 + 1] - 1)
        Ai[p] < pk && continue
        Y[i] += conj(Ax[p])
        len = 1
        @inbounds while flag[i] != k
          pattern[len] = i
          len += 1
          flag[i] = k
          i = parent[i]
        end
        @inbounds while len > 1
          top -= 1
          len -= 1
          pattern[top] = pattern[len]
        end
        break
      end
    end
    D[k] = Y[k]
    Y[k] = Y_zero
    @inbounds while top ≤ n
      i = pattern[top]
      yi = Y[i]
      Y[i] = Y_zero
      @inbounds for p = Lp[i]:(Lp[i] + Lnz[i] - 1)
        Y[Li[p]] -= Lx[p] * yi
      end
      p = Lp[i] + Lnz[i]
      l_ki = yi / D[i]
      D[k] -= conj(l_ki) * yi
      Li[p] = k
      Lx[p] = conj(l_ki)
      Lnz[i] += 1
      top += 1
    end
    if dynamic_reg && abs(D[k]) < tol
      r = P[k] <= n_d ? r1 : r2
      D[k] = sign(r) * max(abs(D[k] + r), abs(r))
    end
    D[k] == 0 && return false
  end
  return true
end

function ldl_numeric!(n, Ap, Ai, Ax, Lp, parent, Lnz, Li, Lx, D, Y, pattern, flag, P, Pinv)
  @inbounds for k = 1:n
    Y[k] = 0
    top = n + 1
    flag[k] = k
    Lnz[k] = 0
    pk = P[k]
    @inbounds for p = Ap[pk]:(Ap[pk + 1] - 1)
      i = Pinv[Ai[p]]
      i > k && continue
      Y[i] += Ax[p]
      len = 1
      @inbounds while flag[i] != k
        pattern[len] = i
        len += 1
        flag[i] = k
        i = parent[i]
      end
      @inbounds while len > 1
        top -= 1
        len -= 1
        pattern[top] = pattern[len]
      end
    end
    D[k] = Y[k]
    Y[k] = 0
    @inbounds while top ≤ n
      i = pattern[top]
      yi = Y[i]
      Y[i] = 0
      @inbounds for p = Lp[i]:(Lp[i] + Lnz[i] - 1)
        Y[Li[p]] -= Lx[p] * yi
      end
      p = Lp[i] + Lnz[i]
      l_ki = yi / D[i]
      D[k] -= conj(l_ki) * yi
      Li[p] = k
      Lx[p] = conj(l_ki)
      Lnz[i] += 1
      top += 1
    end
    D[k] == 0 && return false
  end
  return true
end

# solve functions for a single rhs
function ldl_lsolve!(n, x::AbstractVector, Lp, Li, Lx)
  @inbounds for j = 1:n
    xj = x[j]
    @simd for p = Lp[j]:(Lp[j + 1] - 1)
      x[Li[p]] -= Lx[p] * xj
    end
  end
  return x
end

function ldl_dsolve!(n, x::AbstractVector, D)
  x ./= D
  return x
end

function ldl_ltsolve!(n, x::AbstractVector, Lp, Li, Lx)
  @inbounds for j = n:-1:1
    xj = x[j]
    @simd for p = Lp[j]:(Lp[j + 1] - 1)
      xj -= conj(Lx[p]) * x[Li[p]]
    end
    x[j] = xj
  end
  return x
end

function ldl_solve!(n, b::AbstractVector, Lp, Li, Lx, D, P)
  @views y = b[P]
  ldl_lsolve!(n, y, Lp, Li, Lx)
  ldl_dsolve!(n, y, D)
  ldl_ltsolve!(n, y, Lp, Li, Lx)
  return b
end

# solve functions for multiple rhs
function ldl_lsolve!(n, X::AbstractMatrix, Lp, Li, Lx)
  @inbounds for j = 1:n
    @inbounds for p = Lp[j]:(Lp[j + 1] - 1)
      for k ∈ axes(X, 2)
        X[Li[p], k] -= Lx[p] * X[j, k]
      end
    end
  end
  return X
end

function ldl_dsolve!(n, X::AbstractMatrix, D)
  @inbounds for j = 1:n
    for k ∈ axes(X, 2)
      X[j, k] /= D[j]
    end
  end
  return X
end

function ldl_ltsolve!(n, X::AbstractMatrix, Lp, Li, Lx)
  @inbounds for j = n:-1:1
    @inbounds for p = Lp[j]:(Lp[j + 1] - 1)
      for k ∈ axes(X, 2)
        X[j, k] -= conj(Lx[p]) * X[Li[p], k]
      end
    end
  end
  return X
end

function ldl_solve!(n, B::AbstractMatrix, Lp, Li, Lx, D, P)
  @views Y = B[P, :]
  ldl_lsolve!(n, Y, Lp, Li, Lx)
  ldl_dsolve!(n, Y, D)
  ldl_ltsolve!(n, Y, Lp, Li, Lx)
  return B
end

# compute L*D*L'*x where x is a vector
function ldl_ltmul!(n, x::AbstractVector, Lp, Li, Lx)
  @inbounds for j = 1:n
    xj = x[j]
    @inbounds for p = Lp[j]:(Lp[j + 1] - 1)
      xj += conj(Lx[p]) * x[Li[p]]
    end
    x[j] = xj
  end
  return x
end

function ldl_dmul!(n, x::AbstractVector, D)
  @inbounds for j = 1:n
    x[j] *= D[j]
  end
  return x
end

function ldl_lmul!(n, x::AbstractVector, Lp, Li, Lx)
  @inbounds for j = n:-1:1
    xj = x[j]
    @inbounds for p = Lp[j]:(Lp[j + 1] - 1)
      x[Li[p]] += Lx[p] * xj
    end
  end
  return x
end

function ldl_mul!(n, x::AbstractVector, Lp, Li, Lx, D, P)
  @views y = x[P]
  ldl_ltmul!(n, y, Lp, Li, Lx)
  ldl_dmul!(n, y, D)
  ldl_lmul!(n, y, Lp, Li, Lx)
  return x
end

# compute L*D*L'*X where X is a matrix
function ldl_ltmul!(n, X::AbstractMatrix, Lp, Li, Lx)
  @inbounds for j = 1:n
    @inbounds for p = Lp[j]:(Lp[j + 1] - 1)
      for k ∈ axes(X, 2)
        X[j, k] += conj(Lx[p]) * X[Li[p], k]
      end
    end
  end
  return X
end

function ldl_dmul!(n, X::AbstractMatrix, D)
  @inbounds for j = 1:n
    @inbounds for k ∈ axes(X, 2)
      X[j, k] *= D[j]
    end
  end
  return X
end

function ldl_lmul!(n, X::AbstractMatrix, Lp, Li, Lx)
  @inbounds for j = n:-1:1
    @inbounds for p = Lp[j]:(Lp[j + 1] - 1)
      for k ∈ axes(X, 2)
        X[Li[p], k] += Lx[p] * X[j, k]
      end
    end
  end
  return X
end

function ldl_mul!(n, X::AbstractMatrix, Lp, Li, Lx, D, P)
  @views Y = X[P, :]
  ldl_ltmul!(n, Y, Lp, Li, Lx)
  ldl_dmul!(n, Y, D)
  ldl_lmul!(n, Y, Lp, Li, Lx)
  return X
end

"""
Type that contains the LDLᵀ factorization of a matrix.

The components of the factorization can be accessed via `getproperty`:

- `LDL.L`: `L` sparse lower triangular factor of the factorization without the diagonal 
    of ones that is removed to save space
- `LDL.D`: `D` diagonal matrix of the factorization.

In order to avoid zero pivots during the factorization, the user can regularize the matrix by modifying 
`LDL.r1` for the `LDL.n_d` first pivots and `LDL.r2` for the other pivots with tolerance `LDL.tol`.
"""
mutable struct LDLFactorization{T <: Number, Ti <: Integer, Tn <: Integer, Tp <: Integer} <: Factorization{T}
  __analyzed::Bool
  __factorized::Bool
  __upper::Bool
  n::Tn
  # fields related to symbolic analysis
  parent::Vector{Ti}
  Lnz::Vector{Ti}
  flag::Vector{Ti}
  P::Vector{Tp}
  pinv::Vector{Tp}
  Lp::Vector{Ti}
  Cp::Vector{Ti}
  Ci::Vector{Ti}
  # fields related to numerical factorization
  Li::Vector{Ti}
  Lx::Vector{T}
  d::Vector{T}
  Y::Vector{T}
  pattern::Vector{Ti}
  # fields related to dynamic regularization
  r1::T
  r2::T
  tol::T
  n_d::Tn
end

"""
    isfact = factorized(LDL)

Returns true if the most recent factorization stored in `LDL` [`LDLFactorization`](@ref) succeeded.
"""
factorized(
  LDL::LDLFactorization{T, Ti, Tn, Tp},
) where {T <: Number, Ti <: Integer, Tn <: Integer, Tp <: Integer} = LDL.__factorized

"""
    LDL = ldl_analyze(A, Tf; P = amd(A))
    LDL = ldl_analyze(A; P = amd(A))
    LDL = ldl_analyze(A)

Perform symbolic analysis of the matrix `A` with permutation vector `P` (uses an
AMD permutation by default) so it can be reused.
`Tf` should be the element type of the factors, and is set to `eltype(A)` if not provided.
`A` should be a upper triangular matrix wrapped with LinearAlgebra's Symmetric / Hermitian type.

# Example
    A = sprand(Float64, 10, 10, 0.2)
    As = Symmetric(triu(A * A' + I), :U)
    LDL = ldl_analyze(As) # LDL in Float64
    LDL = ldl_analyze(As, Float32) # LDL in Float64
"""
function ldl_analyze end

"""
    ldl_factorize!(A, S)

Factorize A into the S [`LDLFactorization`](@ref) struct.
"""
function ldl_factorize! end

"""
    S = ldl(A, Tf; P = amd(A))
    S = ldl(A; P = amd(A))
    S = ldl(A)

Compute the LDLᵀ factorization of the matrix A with permutation vector P (uses an
AMD permutation by default).
`Tf` should be the element type of the factors, and is set to `eltype(A)` if not provided.
This function is equivalent to:

    S = ldl_analyze(A)
    ldl_factorize!(A, S)

A should either be a upper triangular matrix wrapped with LinearAlgebra's Symmetric / Hermitian
type, or a symmetric / hermitian matrix (not wrapped with Symmetric / Hermitian).

Using a non upper triangular matrix wrapped with Symmetric or Hermitian will not give the LDLᵀ factorization
of A.

# Example
    A = sprand(Float64, 10, 10, 0.2)
    As = Symmetric(triu(A * A' + I), :U)
    LDL = ldl(As) # LDL in Float64
    LDL = ldl(As, Float32) # LDL in Float64
"""
function ldl end

for (wrapper) in (:Symmetric, :Hermitian)
  @eval begin
    function ldl_analyze(
      A::$wrapper{T, SparseMatrixCSC{T, Ti}},
      ::Type{Tf};
      P::Vector{Tp} = amd(A),
    ) where {T <: Number, Ti <: Integer, Tp <: Integer, Tf <: Number}
      A.uplo == 'U' || error("upper triangle must be supplied")
      n = size(A, 1)
      n == size(A, 2) || throw(DimensionMismatch("matrix must be square"))
      n == length(P) || throw(DimensionMismatch("permutation size mismatch"))

      # allocate space for symbolic analysis
      parent = Vector{Ti}(undef, n)
      Lnz = Vector{Ti}(undef, n)
      flag = Vector{Ti}(undef, n)
      pinv = Vector{Tp}(undef, n)
      Lp = Vector{Ti}(undef, n + 1)

      # Compute inverse permutation
      @inbounds for k = 1:n
        pinv[P[k]] = k
      end

      Cp = Vector{Ti}(undef, n + 1)
      col_symb!(n, A.data.colptr, A.data.rowval, Cp, Lp, pinv)
      Ci = Vector{Ti}(undef, Cp[end] - 1)
      col_num!(n, A.data.colptr, A.data.rowval, Ci, Lp, pinv)

      # perform symbolic analysis
      ldl_symbolic_upper!(n, A.data.colptr, A.data.rowval, Cp, Ci, Lp, parent, Lnz, flag, P, pinv)

      # space for numerical factorization will be allocated later
      Li = Vector{Ti}(undef, Lp[n] - 1)
      Lx = Vector{Tf}(undef, Lp[n] - 1)
      d = Vector{Tf}(undef, n)
      Y = Vector{Tf}(undef, n)
      pattern = Vector{Ti}(undef, n)
      return LDLFactorization(
        true,
        false,
        true,
        n,
        parent,
        Lnz,
        flag,
        P,
        pinv,
        Lp,
        Cp,
        Ci,
        Li,
        Lx,
        d,
        Y,
        pattern,
        zero(Tf),
        zero(Tf),
        zero(Tf),
        n,
      )
    end

    ldl_analyze(
      A::$wrapper{T, SparseMatrixCSC{T, Ti}};
      kwargs...,
    ) where {T <: Number, Ti <: Integer} = ldl_analyze(A, T, kwargs...)

    # convert dense to sparse
    ldl_analyze(
      A::$wrapper{T, Matrix{T}},
      ::Type{Tf};
      kwargs...,
    ) where {T <: Number, Tf <: Number} = ldl_analyze($wrapper(sparse(A.data)), Tf; kwargs...)
    ldl_analyze(A::$wrapper{T, Matrix{T}}; kwargs...) where {T <: Number} =
      ldl_analyze($wrapper(sparse(A.data)); kwargs...)

    function ldl_factorize!(
      A::$wrapper{T, SparseMatrixCSC{T, Ti}},
      S::LDLFactorization{Tf, Ti, Tn, Tp},
    ) where {T <: Number, Tf <: Number, Ti <: Integer, Tn <: Integer, Tp <: Integer}
      S.__analyzed || error("perform symbolic analysis prior to numerical factorization")
      n = size(A, 1)
      n == S.n ||
        throw(DimensionMismatch("matrix size is inconsistent with symbolic analysis object"))

      # perform numerical factorization
      S.__factorized = ldl_numeric_upper!(
        S.n,
        A.data.colptr,
        A.data.rowval,
        A.data.nzval,
        S.Cp,
        S.Ci,
        S.Lp,
        S.parent,
        S.Lnz,
        S.Li,
        S.Lx,
        S.d,
        S.Y,
        S.pattern,
        S.flag,
        S.P,
        S.pinv,
        S.r1,
        S.r2,
        S.tol,
        S.n_d,
      )
      return S
    end

    # convert dense to sparse
    ldl_factorize!(A::$wrapper{T, Matrix{T}}, S::LDLFactorization) where {T <: Number} =
      ldl_factorize!($wrapper(sparse(A.data)), S)

    # symmetric or hermitian matrix input
    function ldl(
      sA::$wrapper{T, SparseMatrixCSC{T, Ti}},
      ::Type{Tf};
      P::Vector{Tp} = amd(sA),
    ) where {T <: Number, Ti <: Integer, Tp <: Integer, Tf <: Number}
      sA.uplo == 'L' && error("matrix must contain the upper triangle")
      # ldl(sA.data, args...; upper = true )
      S = ldl_analyze(sA, Tf; P = P)
      ldl_factorize!(sA, S)
    end

    ldl(sA::$wrapper{T, SparseMatrixCSC{T, Ti}}; kwargs...) where {T <: Number, Ti <: Integer} =
      ldl(sA, T; kwargs...)

    ldl(sA::$wrapper{T, Matrix{T}}, ::Type{Tf}; kwargs...) where {T <: Number, Tf <: Number} =
      ldl($wrapper(sparse(sA.data)), Tf; kwargs...)
    ldl(sA::$wrapper{T, Matrix{T}}; kwargs...) where {T <: Number} =
      ldl($wrapper(sparse(sA.data)), T; kwargs...)
  end
end

# use ldl(A, P = collect(1:n)) to suppress permutation
function ldl_analyze(
  A::SparseMatrixCSC{T, Ti},
  ::Type{Tf};
  P::Vector{Tp} = amd(A),
) where {T <: Number, Ti <: Integer, Tp <: Integer, Tf <: Number}
  n = size(A, 1)
  n == size(A, 2) || throw(DimensionMismatch("matrix must be square"))
  n == length(P) || throw(DimensionMismatch("permutation size mismatch"))

  # allocate space for symbolic analysis
  parent = Vector{Ti}(undef, n)
  Lnz = Vector{Ti}(undef, n)
  flag = Vector{Ti}(undef, n)
  pinv = Vector{Tp}(undef, n)
  Lp = Vector{Ti}(undef, n + 1)
  Cp = Ti[]
  Ci = Ti[]

  # Compute inverse permutation
  @inbounds for k = 1:n
    pinv[P[k]] = k
  end

  ldl_symbolic!(n, A.colptr, A.rowval, Lp, parent, Lnz, flag, P, pinv)

  # space for numerical factorization will be allocated later
  Li = Vector{Ti}(undef, Lp[n] - 1)
  Lx = Vector{Tf}(undef, Lp[n] - 1)
  d = Vector{Tf}(undef, n)
  Y = Vector{Tf}(undef, n)
  pattern = Vector{Ti}(undef, n)
  return LDLFactorization(
    true,
    false,
    false,
    n,
    parent,
    Lnz,
    flag,
    P,
    pinv,
    Lp,
    Cp,
    Ci,
    Li,
    Lx,
    d,
    Y,
    pattern,
    zero(Tf),
    zero(Tf),
    zero(Tf),
    n,
  )
end

ldl_analyze(A::SparseMatrixCSC{T}; kwargs...) where {T <: Number} = ldl_analyze(A, T; kwargs...)

# convert dense to sparse
ldl_analyze(A::Matrix{T}, ::Type{Tf}; kwargs...) where {T <: Number, Tf <: Number} =
  ldl_analyze(sparse(A), Tf; kwargs...)
ldl_analyze(A::Matrix{T}, kwargs...) where {T <: Number} = ldl_analyze(sparse(A), T, kwargs...)

function ldl_factorize!(
  A::SparseMatrixCSC{T, Ti},
  S::LDLFactorization{Tf, Ti, Tn, Tp},
) where {T <: Number, Tf <: Number, Ti <: Integer, Tn <: Integer, Tp <: Integer}
  S.__upper && error("symbolic analysis was performed for a Symmetric{} / Hermitian{} matrix")
  S.__analyzed || error("perform symbolic analysis prior to numerical factorization")
  n = size(A, 1)
  n == S.n || throw(DimensionMismatch("matrix size is inconsistent with symbolic analysis object"))

  S.__factorized = ldl_numeric!(
    S.n,
    A.colptr,
    A.rowval,
    A.nzval,
    S.Lp,
    S.parent,
    S.Lnz,
    S.Li,
    S.Lx,
    S.d,
    S.Y,
    S.pattern,
    S.flag,
    S.P,
    S.pinv,
  )
  return S
end

# convert dense to sparse
ldl_factorize!(A::Matrix{T}, S::LDLFactorization) where {T <: Number} = ldl_factorize!(sparse(A), S)

function ldl(A::SparseMatrixCSC, ::Type{Tf}; kwargs...) where {Tf <: Number}
  S = ldl_analyze(A, Tf; kwargs...)
  ldl_factorize!(A, S)
end

ldl(A::SparseMatrixCSC{T}; kwargs...) where {T <: Number} = ldl(sparse(A), T; kwargs...)

ldl(A::Matrix{T}, ::Type{Tf}; kwargs...) where {T <: Number, Tf <: Number} =
  ldl(sparse(A), Tf; kwargs...)
ldl(A::Matrix{T}; kwargs...) where {T <: Number} = ldl(sparse(A), T; kwargs...)

import Base.(\)

"""
    x = LDL \\ b 

If LDL is the LDLᵀ factorization of A, solves ``A x = b``.
"""
function (\)(
  LDL::LDLFactorization{Tf, Ti, Tn, Tp},
  b::AbstractVector{T},
) where {T <: Number, Tf <: Number, Ti <: Integer, Tn <: Integer, Tp <: Integer}
  y = copy(b)
  LDL.__factorized || throw(SQDException(error_string))
  ldl_solve!(LDL.n, y, LDL.Lp, LDL.Li, LDL.Lx, LDL.d, LDL.P)
end

function (\)(
  LDL::LDLFactorization{Tf, Ti, Tn, Tp},
  B::AbstractMatrix{T},
) where {T <: Number, Tf <: Number, Ti <: Integer, Tn <: Integer, Tp <: Integer}
  Y = copy(B)
  LDL.__factorized || throw(SQDException(error_string))
  ldl_solve!(LDL.n, Y, LDL.Lp, LDL.Li, LDL.Lx, LDL.d, LDL.P)
end

import LinearAlgebra.ldiv!

"""
    ldiv!(LDL, b) 

If LDL is the LDLᵀ factorization of A, solves `A x = b` and overwrites b with x.
"""
@inline ldiv!(
  LDL::LDLFactorization{Tf, Ti, Tn, Tp},
  b::AbstractVector{T},
) where {T <: Number, Tf <: Number, Ti <: Integer, Tn <: Integer, Tp <: Integer} =
  LDL.__factorized ? ldl_solve!(LDL.n, b, LDL.Lp, LDL.Li, LDL.Lx, LDL.d, LDL.P) :
  throw(SQDException(error_string))

@inline ldiv!(
  LDL::LDLFactorization{Tf, Ti, Tn, Tp},
  B::AbstractMatrix{T},
) where {T <: Number, Tf <: Number, Ti <: Integer, Tn <: Integer, Tp <: Integer} =
  LDL.__factorized ? ldl_solve!(LDL.n, B, LDL.Lp, LDL.Li, LDL.Lx, LDL.d, LDL.P) :
  throw(SQDException(error_string))

"""
    ldiv!(y, LDL, b) 

If LDL is the LDLᵀ factorization of A, solves `A x = b` In place.
"""
function ldiv!(
  y::AbstractVector{T},
  LDL::LDLFactorization{Tf, Ti, Tn, Tp},
  b::AbstractVector{T},
) where {T <: Number, Tf <: Number, Ti <: Integer, Tn <: Integer, Tp <: Integer}
  y .= b
  LDL.__factorized || throw(SQDException(error_string))
  ldl_solve!(LDL.n, y, LDL.Lp, LDL.Li, LDL.Lx, LDL.d, LDL.P)
end

function ldiv!(
  Y::AbstractMatrix{T},
  LDL::LDLFactorization{Tf, Ti, Tn, Tp},
  B::AbstractMatrix{T},
) where {T <: Number, Tf <: Number, Ti <: Integer, Tn <: Integer, Tp <: Integer}
  Y .= B
  LDL.__factorized || throw(SQDException(error_string))
  ldl_solve!(LDL.n, Y, LDL.Lp, LDL.Li, LDL.Lx, LDL.d, LDL.P)
end

import LinearAlgebra.lmul!, LinearAlgebra.mul!
function lmul!(
  LDL::LDLFactorization{Tf, Ti, Tn, Tp},
  x::AbstractVector{T},
) where {T <: Number, Tf <: Number, Ti <: Integer, Tn <: Integer, Tp <: Integer}
  LDL.__factorized || throw(SQDException(error_string))
  ldl_mul!(LDL.n, x, LDL.Lp, LDL.Li, LDL.Lx, LDL.d, LDL.P)
end

function lmul!(
  LDL::LDLFactorization{Tf, Ti, Tn, Tp},
  X::AbstractMatrix{T},
) where {T <: Number, Tf <: Number, Ti <: Integer, Tn <: Integer, Tp <: Integer}
  LDL.__factorized || throw(SQDException(error_string))
  ldl_mul!(LDL.n, X, LDL.Lp, LDL.Li, LDL.Lx, LDL.d, LDL.P)
end

function mul!(
  y::AbstractVector{T},
  LDL::LDLFactorization{Tf, Ti, Tn, Tp},
  x::AbstractVector{T},
) where {T <: Number, Tf <: Number, Ti <: Integer, Tn <: Integer, Tp <: Integer}
  y .= x
  LDL.__factorized || throw(SQDException(error_string))
  ldl_mul!(LDL.n, y, LDL.Lp, LDL.Li, LDL.Lx, LDL.d, LDL.P)
end

function mul!(
  Y::AbstractMatrix{T},
  LDL::LDLFactorization{Tf, Ti, Tn, Tp},
  X::AbstractMatrix{T},
) where {T <: Number, Tf <: Number, Ti <: Integer, Tn <: Integer, Tp <: Integer}
  Y .= X
  LDL.__factorized || throw(SQDException(error_string))
  ldl_mul!(LDL.n, Y, LDL.Lp, LDL.Li, LDL.Lx, LDL.d, LDL.P)
end

Base.eltype(LDL::LDLFactorization) = eltype(LDL.d)
Base.size(LDL::LDLFactorization) = (LDL.n, LDL.n)
SparseArrays.nnz(LDL::LDLFactorization) = length(LDL.Lx) + length(LDL.d)

# user-friendly factors
@inline function Base.getproperty(LDL::LDLFactorization, prop::Symbol)
  if prop == :L
    # TODO: permute and return UnitLowerTriangular()
    return SparseMatrixCSC(LDL.n, LDL.n, LDL.Lp, LDL.Li, LDL.Lx)
  elseif prop == :D
    return Diagonal(LDL.d)
  else
    getfield(LDL, prop)
  end
end

Base.propertynames(LDL::LDLFactorization) = (:L, :D, :P)

import Base.(-)

"""
    -(LDL)

Unary minus operator returns an `LDLFactorization` with `-LDL.d`.
"""
function (-)(
  LDL::LDLFactorization{Tf, Ti, Tn, Tp},
) where {Tf <: Number, Ti <: Integer, Tn <: Integer, Tp <: Integer}
  LDL.d .= -LDL.d
  return LDL
end

end  # module

using DataFrames
using JLD2
using PkgBenchmark
using Plots

using SolverBenchmark

pyplot()
using PlotThemes
theme(:wong)

common_plot_args = Dict{Symbol, Any}(
  :linewidth => 2,
  :alpha => 0.75,
  :titlefontsize => 8,
  :legendfontsize => 8,
  :xtickfontsize => 6,
  :ytickfontsize => 6,
  :guidefontsize => 8,
)
Plots.default(; common_plot_args...)

# perform benchmarks
results = PkgBenchmark.benchmarkpkg("LDLFactorizations", script = "benchmark/sqd_bmark.jl")
stats = bmark_results_to_dataframes(results)
save_stats(stats, "ldl_vs_qdldl.jld2")

# process benchmark results and post gist
p = profile_solvers(results)
savefig("LDLFactorizations_benchmark.svg")
posted_gist = to_gist(results, p)
println(posted_gist.html_url)

@testset "real" begin
  @testset "factorizable" begin
    # this matrix possesses an LDLᵀ factorization without pivoting
    A = [
      1.7 0 0 0 0 0 0 0 0.13 0
      0 1.0 0 0 0.02 0 0 0 0 0.01
      0 0 1.5 0 0 0 0 0 0 0
      0 0 0 1.1 0 0 0 0 0 0
      0 0.02 0 0 2.6 0 0.16 0.09 0.52 0.53
      0 0 0 0 0 1.2 0 0 0 0
      0 0 0 0 0.16 0 1.3 0 0 0.56
      0 0 0 0 0.09 0 0 1.6 0.11 0
      0.13 0 0 0 0.52 0 0 0.11 1.4 0
      0 0.01 0 0 0.53 0 0.56 0 0 3.1
    ]
    b = [0.287, 0.22, 0.45, 0.44, 2.486, 0.72, 1.55, 1.424, 1.621, 3.759]
    ϵ = sqrt(eps(eltype(A)))

    LDLT = ldl(A)
    x = LDLT \ b

    r = A * x - b
    @test norm(r) ≤ ϵ * norm(b)

    y = collect(0.1:0.1:1)
    @test norm(x - y) ≤ ϵ * norm(y)

    x2 = copy(b)
    ldiv!(LDLT, x2)

    r2 = A * x2 - b
    @test norm(r2) ≤ ϵ * norm(b)

    @test norm(x2 - y) ≤ ϵ * norm(y)

    @test norm(A[LDLT.P, LDLT.P] - (LDLT.L + I) * LDLT.D * (LDLT.L + I)') ≤ ϵ

    # test properties
    @test eltype(LDLT) == eltype(A)
    @test nnz(LDLT) == nnz(LDLT.L) + length(LDLT.d)
    @test size(LDLT) == size(A)
    @test typeof(LDLT.D) <: Diagonal
    @test propertynames(LDLT) == (:L, :D, :P)
  end

  @testset "not_factorizable" begin
    # this matrix does not possess an LDLᵀ factorization without pivoting
    A = [
      0 1
      1 1
    ]
    S = ldl(A, P = [1, 2])
    @test !factorized(S)

    A = Symmetric(sparse(triu(A)))
    S = ldl_analyze(A)
    ldl_factorize!(A, S)
    @test !factorized(S)
  end

  @testset "sparse" begin
    for Ti in (Int32, Int), Tf in (Float32, Float64, BigFloat)
      A = sparse(Ti[1, 2, 1, 2], Ti[1, 1, 2, 2], Tf[10, 2, 2, 5])
      z = ones(Tf, 2)
      b = A * z
      LDLT = ldl(A)
      x = LDLT \ b
      @test norm(x - z) ≤ sqrt(eps(Tf)) * norm(z)
      r = A * x - b
      @test norm(r) ≤ sqrt(eps(Tf)) * norm(b)

      x2 = copy(b)
      ldiv!(LDLT, x2)
      @test norm(x2 - z) ≤ sqrt(eps(Tf)) * norm(z)
      r2 = A * x2 - b
      @test norm(r2) ≤ sqrt(eps(Tf)) * norm(b)

      y = similar(b)
      ldiv!(y, LDLT, b)
      @test norm(y - z) ≤ sqrt(eps(Tf)) * norm(z)
      r2 = A * y - b
      @test norm(r2) ≤ sqrt(eps(Tf)) * norm(b)

      @test nnz(LDLT) == nnz(LDLT.L) + length(LDLT.d)

      # test with separate analyze/factorize phases
      # A = Symmetric(sparse(triu(A)))
      S = ldl_analyze(A)
      ldl_factorize!(A, S)
      x2 = copy(b)
      ldiv!(LDLT, x2)
      @test norm(x2 - z) ≤ sqrt(eps(Tf)) * norm(z)
      r2 = A * x2 - b
      @test norm(r2) ≤ sqrt(eps(Tf)) * norm(b)
    end
  end

  @testset "factorizable_upper" begin
    # Using only the upper triangle tests
    A = [
      1.7 0 0 0 0 0 0 0 0.13 0
      0 1.0 0 0 0.02 0 0 0 0 0.01
      0 0 1.5 0 0 0 0 0 0 0
      0 0 0 1.1 0 0 0 0 0 0
      0 0.02 0 0 2.6 0 0.16 0.09 0.52 0.53
      0 0 0 0 0 1.2 0 0 0 0
      0 0 0 0 0.16 0 1.3 0 0 0.56
      0 0 0 0 0.09 0 0 1.6 0.11 0
      0.13 0 0 0 0.52 0 0 0.11 1.4 0
      0 0.01 0 0 0.53 0 0.56 0 0 3.1
    ]
    b = [0.287, 0.22, 0.45, 0.44, 2.486, 0.72, 1.55, 1.424, 1.621, 3.759]
    ϵ = sqrt(eps(eltype(A)))
    LDLT = ldl(A)

    A_upper = Symmetric(triu(A), :U)
    LDLT_upper = ldl(A_upper)
    x = LDLT_upper \ b

    y = collect(0.1:0.1:1)
    @test norm(x - y) ≤ ϵ * norm(y)

    r = A * x - b
    @test norm(r) ≤ ϵ * norm(b)

    x2 = copy(b)
    ldiv!(LDLT, x2)
    @test norm(x2 - y) ≤ ϵ * norm(y)

    r2 = A * x2 - b
    @test norm(r2) ≤ ϵ * norm(b)

    @test nnz(LDLT_upper) == nnz(LDLT_upper.L) + length(LDLT_upper.d)

    # test with separate analyze/factorize phases
    # A = Symmetric(sparse(triu(A)))
    S = ldl_analyze(A)
    ldl_factorize!(A, S)
    x2 = copy(b)
    ldiv!(LDLT, x2)
    @test norm(x2 - y) ≤ ϵ * norm(y)
    r2 = A * x2 - b
    @test norm(r2) ≤ ϵ * norm(b)

    # test with a permutation of a different int type
    p = Int32.(collect(size(A, 1):-1:1))
    LDLT_upper = ldl(A_upper, P = p)
    x = LDLT_upper \ b

    y = collect(0.1:0.1:1)
    @test norm(x - y) ≤ ϵ * norm(y)

    r = A * x - b
    @test norm(r) ≤ ϵ * norm(b)

    x2 = copy(b)
    ldiv!(LDLT, x2)
    @test norm(x2 - y) ≤ ϵ * norm(y)

    r2 = A * x2 - b
    @test norm(r2) ≤ ϵ * norm(b)

    # Tests with multiple right-hand sides
    B = 1.0 * [i + j for j = 1:10, i = 0:3]
    X = A \ B
    Y = similar(B)
    ldiv!(Y, LDLT, B)
    @test norm(Y - X) ≤ ϵ * norm(X)
  end

  @testset "not_factorizable_upper" begin
    # this matrix does not possess an LDLᵀ factorization without pivoting
    A = triu([
      0 1
      1 1
    ])
    S = ldl(A, P = [1, 2])
    @test !factorized(S)

    S = ldl_analyze(Symmetric(A, :U))
    ldl_factorize!(Symmetric(A, :U), S)
    @test !S.__factorized
  end

  @testset "sparse_upper" begin
    for Ti in (Int32, Int), Tf in (Float32, Float64, BigFloat)
      A = sparse(Ti[1, 2, 1, 2], Ti[1, 1, 2, 2], Tf[10, 2, 2, 5])
      A_upper = Symmetric(triu(A), :U)
      b = A * ones(Tf, 2)
      LDLT = ldl(A_upper)
      x = LDLT \ b
      r = A * x - b
      @test norm(r) ≤ sqrt(eps(Tf)) * norm(b)

      x2 = copy(b)
      ldiv!(LDLT, x2)
      r2 = A * x2 - b
      @test norm(r2) ≤ sqrt(eps(Tf)) * norm(b)

      @test nnz(LDLT) == nnz(LDLT.L) + length(LDLT.d)
    end
  end

  @testset "positive_semidefinite" begin
    A = [
      0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 4.0 0.0
      0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 5.0 0.0
      2.0 4.0 5.0 -2 4.0 1.0 2.0 2.0 2.0 0.0
      0.0 0.0 0.0 0.0 1.0 9.0 9.0 1.0 7.0 1.0
      0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0
      1.0 3.0 2.0 1.0 4.0 3.0 1.0 0.0 0.0 7.0
      -3.0 8.0 0.0 0.0 0.0 0.0 -2.0 0.0 0.0 1.0
      0.0 0.0 0.0 5.0 7.0 9.0 0.0 2.0 7.0 1.0
      3.0 2.0 0.0 0.0 0.0 0.0 1.0 3.0 3.0 2.0
      0.0 0.0 0.0 0.0 -3 -4 0.0 0.0 0.0 0.0
    ]
    ϵ = sqrt(eps(eltype(A)))
    M = A * A'  # det(A) = 0 => M positive semidefinite
    b = M * ones(10)
    x = copy(b)
    S = ldl_analyze(Symmetric(triu(M), :U))
    S.r1 = -ϵ
    S.r2 = ϵ
    S.tol = ϵ
    S.n_d = 0
    S = ldl_factorize!(Symmetric(triu(M), :U), S)
    x = ldiv!(S, x)
    r = M * x - b
    @test norm(r) ≤ sqrt(eps()) * norm(b)
  end

  @testset "SQD" begin
    A = [
      0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 4.0 0.0
      0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 5.0 0.0
      2.0 4.0 5.0 -2 4.0 1.0 2.0 2.0 2.0 0.0
      0.0 0.0 0.0 0.0 1.0 9.0 9.0 1.0 7.0 1.0
      0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0
      1.0 3.0 2.0 1.0 4.0 3.0 1.0 0.0 0.0 7.0
      -3.0 8.0 0.0 0.0 0.0 0.0 -2.0 0.0 0.0 1.0
      0.0 0.0 0.0 5.0 7.0 9.0 0.0 2.0 7.0 1.0
      3.0 2.0 0.0 0.0 0.0 0.0 1.0 3.0 3.0 2.0
      0.0 0.0 0.0 0.0 -3 -4 0.0 0.0 0.0 0.0
    ]
    ϵ = sqrt(eps(eltype(A)))
    M = spzeros(20, 20)
    M[1:10, 1:10] = -A * A'
    M[11:20, 11:20] = A * A'
    # M = [-A*A'    0
    #        0     A*A'] where A*A' is symmetric positive semidefinite
    b = M * ones(20)
    x = copy(b)
    S = ldl_analyze(Symmetric(triu(M), :U))
    S.r1 = -ϵ
    S.r2 = ϵ
    S.tol = ϵ
    S.n_d = 10
    S = ldl_factorize!(Symmetric(triu(M), :U), S)
    x = ldiv!(S, x)
    r = M * x - b
    @test norm(r) ≤ sqrt(eps()) * norm(b)
  end

  @testset "SQD_semi_dynamic" begin
    A = [
      0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 4.0 0.0
      0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 5.0 0.0
      2.0 4.0 5.0 -2 4.0 1.0 2.0 2.0 2.0 0.0
      0.0 0.0 0.0 0.0 1.0 9.0 9.0 1.0 7.0 1.0
      0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0
      1.0 3.0 2.0 1.0 4.0 3.0 1.0 0.0 0.0 7.0
      -3.0 8.0 0.0 0.0 0.0 0.0 -2.0 0.0 0.0 1.0
      0.0 0.0 0.0 5.0 7.0 9.0 0.0 2.0 7.0 1.0
      3.0 2.0 0.0 0.0 0.0 0.0 1.0 3.0 3.0 2.0
      0.0 0.0 0.0 0.0 -3 -4 0.0 0.0 0.0 0.0
    ]
    ϵ = sqrt(eps(eltype(A)))
    M = spzeros(20, 20)
    M[1:10, 1:10] = A * A' + ϵ * I
    M[11:20, 11:20] = -A * A'
    # M = [-A*A'    0
    #        0     A*A'] where A*A' is symmetric positive semidefinite
    b = M * ones(20)
    x = copy(b)
    S = ldl_analyze(Symmetric(triu(M), :U))
    S.r1 = zero(eltype(A))
    S.r2 = -ϵ
    S.tol = ϵ
    S.n_d = 10
    S = ldl_factorize!(Symmetric(triu(M), :U), S)
    x = ldiv!(S, x)
    r = M * x - b
    @test norm(r) ≤ sqrt(eps()) * norm(b)
  end

  @testset "Test booleans and allocations" begin
    A = spdiagm(0 => 2 * ones(10), 1 => -ones(9))
    ϵ = √eps()
    M1 = spzeros(20, 20)
    M1[1:10, 1:10] = A
    M1[11:20, 11:20] = spdiagm(0 => -ϵ * ones(10))
    M2 = spzeros(20, 20)
    M2[1:10, 1:10] = A
    M2[11:20, 11:20] = spdiagm(0 => -100ϵ * ones(10))
    M3 = spzeros(20, 20)
    M3[1:10, 1:10] = A
    M3[11:20, 11:20] = spdiagm(0 => zeros(10))

    S = ldl_analyze(M1)
    @test !factorized(S)
    _allocs1 = @allocated ldl_factorize!(M1, S)
    @test S.d[11:20] ≈ -ϵ * ones(10)
    @test factorized(S)
    _allocs2 = @allocated ldl_factorize!(M2, S)
    @test S.d[11:20] ≈ -100ϵ * ones(10)
    @test _allocs1 == _allocs2
    ldl_factorize!(M3, S)
    @test !factorized(S)
    b = ones(20)
    @test_throws LDLFactorizations.SQDException ldiv!(S, b)
    @test_throws LDLFactorizations.SQDException lmul!(S, b)
    B = ones(20, 2)
    @test_throws LDLFactorizations.SQDException ldiv!(S, B)
  end

  @testset "ldl_mul!" begin
    A0 = [
      0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 4.0 0.0
      0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0 5.0 0.0
      2.0 4.0 5.0 -2 4.0 1.0 2.0 2.0 2.0 0.0
      0.0 0.0 0.0 0.0 1.0 9.0 9.0 1.0 7.0 1.0
      0.0 -7.0 0.0 4.0 0.0 0.0 0.0 0.0 1.0 0.0
      1.0 3.0 2.0 1.0 4.0 3.0 1.0 0.0 0.0 7.0
      -3.0 8.0 0.0 0.0 0.0 0.0 -2.0 0.0 0.0 1.0
      0.0 0.0 0.0 5.0 7.0 9.0 0.0 2.0 7.0 1.0
      3.0 2.0 0.0 0.0 0.0 0.0 1.0 3.0 3.0 2.0
      0.0 0.0 0.0 0.0 -3 -4 0.0 0.0 0.0 0.0
    ]
    A = A0 * A0'
    b = A * ones(10)
    T = eltype(A)
    ϵ = sqrt(eps(T))
    S = ldl_analyze(Symmetric(triu(A), :U))
    ldl_factorize!(Symmetric(triu(A), :U), S)
    x = copy(b)
    ldiv!(S, x)
    r1 = copy(x)
    lmul!(S, r1)
    @test norm(r1 - A * x) ≤ sqrt(ϵ) * norm(r1)
    r1 .-= b  # r1 = LDL*x-b
    @test norm(r1) ≤ sqrt(ϵ) * norm(b)
    mul!(r1, S, x) # same test using mul!
    @test norm(r1 - A * x) ≤ sqrt(ϵ) * norm(r1)
    r1 .-= b
    @test norm(r1) ≤ sqrt(ϵ) * norm(b)

    LDL1 = spzeros(T, size(A)...)
    LDL1[diagind(LDL1)] .= one(T)
    LDL1 = lmul!(S, LDL1)
    r2 = similar(b)
    mul!(r2, LDL1, x)
    @test norm(r2 - A * x) ≤ sqrt(ϵ) * norm(r2)
    r2 .-= b # r2 = LDL*I*x-b
    @test norm(r2) ≤ sqrt(ϵ) * norm(b)
    LDL2 = spzeros(T, size(A)...)
    LDL2[diagind(LDL2)] .= one(T)
    mul!(LDL2, S, copy(LDL2))
    mul!(r2, LDL2, x) # same test using mul!
    @test norm(r2 - A * x) ≤ sqrt(ϵ) * norm(r2)
    r2 .-= b
    @test norm(r2) ≤ sqrt(ϵ) * norm(b)
  end

  @testset "factorization precision" begin
    A = [
      1.7 0 0 0 0 0 0 0 0.13 0
      0 1.0 0 0 0.02 0 0 0 0 0.01
      0 0 1.5 0 0 0 0 0 0 0
      0 0 0 1.1 0 0 0 0 0 0
      0 0.02 0 0 2.6 0 0.16 0.09 0.52 0.53
      0 0 0 0 0 1.2 0 0 0 0
      0 0 0 0 0.16 0 1.3 0 0 0.56
      0 0 0 0 0.09 0 0 1.6 0.11 0
      0.13 0 0 0 0.52 0 0 0.11 1.4 0
      0 0.01 0 0 0.53 0 0.56 0 0 3.1
    ]
    b = [0.287, 0.22, 0.45, 0.44, 2.486, 0.72, 1.55, 1.424, 1.621, 3.759]
    ϵ = sqrt(eps(eltype(A)))
    m, n = size(A)

    LDL32 = ldl_analyze(A, Float32)
    @test typeof(LDL32) == LDLFactorizations.LDLFactorization{Float32, Int, Int, Int}
    @test eltype(LDL32) == Float32
    ldl_factorize!(A, LDL32)
    @test LDL32.__factorized

    LDL32 = ldl_analyze(Symmetric(triu(A), :U), Float32)
    @test typeof(LDL32) == LDLFactorizations.LDLFactorization{Float32, Int, Int, Int}
    @test eltype(LDL32) == Float32
    ldl_factorize!(Symmetric(triu(A), :U), LDL32)
    @test LDL32.__factorized

    LDL32 = ldl(A, Float32)
    @test typeof(LDL32) == LDLFactorizations.LDLFactorization{Float32, Int, Int, Int}
    @test eltype(LDL32) == Float32
    @test LDL32.__factorized

    LDL32 = ldl(Symmetric(triu(A), :U), Float32)
    @test typeof(LDL32) == LDLFactorizations.LDLFactorization{Float32, Int, Int, Int}
    @test eltype(LDL32) == Float32
    @test LDL32.__factorized

    b, c = rand(n), rand(n)
    d = LDL32 \ b
    @test eltype(d) == Float64
    ldiv!(c, LDL32, b)
    ldiv!(LDL32, b)
    @test eltype(b) == Float64
    @test all(b .== d .== c)

    mul!(c, LDL32, b)
    lmul!(LDL32, b)
    @test eltype(c) == eltype(b) == Float64
    @test all(b .== c)
  end

  @testset "Operations on LDL struct" begin
    A = rand(2, 2)
    b = A * ones(2)
    A = Symmetric(triu(A), :U)
    S = ldl_analyze(A)
    ldl_factorize!(A, S)
    x1 = S \ (-b)
    x2 = -S \ b
    @test x1 == x2
  end
end

# benchmark LDLFactorizations vs QDLDL

using BenchmarkTools
using MatrixMarket

using LinearAlgebra
using Pkg.Artifacts
using Printf
using SparseArrays

using LDLFactorizations
using QDLDL

# obtain path to SQD collection
const artifact_toml = joinpath(@__DIR__, "Artifacts.toml")
const sqd_hash = artifact_hash("sqdcollection", artifact_toml)
@assert artifact_exists(sqd_hash)
const sqd_path = joinpath(artifact_path(sqd_hash), "sqd-collection-0.1")
subdirs = readdir(sqd_path)
const formulations = ("2x2", "3x3")
const iters = (0, 5, 10)

const SUITE = BenchmarkGroup()

for subdir ∈ subdirs
  subdir == ".git" && continue
  isdir(joinpath(sqd_path, subdir)) || continue  # ignore regular files
  for formulation ∈ formulations
    for iter ∈ iters
      iterpath = joinpath(sqd_path, subdir, formulation, "iter_$(iter)")
      isdir(iterpath) || continue
      A = MatrixMarket.mmread(joinpath(iterpath, "K_$(iter).mtx"))
      name = "$(subdir)_$(formulation)_$(iter)"
      SUITE[name] = BenchmarkGroup()
      SUITE[name]["LDL"] = @benchmarkable ldl($A)
      SUITE[name]["QDLDL"] = @benchmarkable qdldl($A)
    end
  end
end

# LDLFactorizations.jl

## Bug reports and discussions

If you think you found a bug, feel free to open an [issue](https://github.com/JuliaSmoothOptimizers/LDLFactorizations.jl/issues).
Focused suggestions and requests can also be opened as issues. Before opening a pull request, start an issue or a discussion on the topic, please.

If you want to ask a question not suited for a bug report, feel free to start a discussion [here](https://github.com/JuliaSmoothOptimizers/Organization/discussions). This forum is for general discussion about this repository and the [JuliaSmoothOptimizers](https://github.com/JuliaSmoothOptimizers) organization, so questions about any of our packages are welcome.

# LDLFactorizations.jl Tutorial

You can check an [Introduction to LDLFactorizations.jl](https://juliasmoothoptimizers.github.io/tutorials/introduction-to-ldlfactorizations/) on our site, [JuliaSmoothOptimizers](https://juliasmoothoptimizers.github.io).
